import configparser
from datetime import timedelta

base_config = {
    "SECRET_KEY": "asdfzxcv",  # session加密
    "PERMANENT_SESSION_LIFETIME": timedelta(days=30),  # 设置session过期时间
    "DEBUG": True,
    # SERVER_NAME : 'example.com'
    "HOST": "0.0.0.0",
    "PORT": 9000,
}


def setup_config(config_path):
    """获取配置文件"""
    conf = configparser.ConfigParser()
    conf.read(config_path)

    new_config = {
        # base
        "SECRET_KEY": conf.get("base", "secret_key"),  # session加密
        "DEBUG": conf.getboolean("base", "debug"),
        "HOST": conf.get("base", "host"),
        "PORT": conf.getint("base", "port"),
        # qdrant
        "QDRANT_HOST": conf.get("qdrant", "qdrant_host"),
        "QDRANT_PORT": conf.get("qdrant", "qdrant_port"),
        # "QDRANT_COLLECTION": conf.get("qdrant", "qdrant_collection"),
        # openai_api_key
        "OPENAI_API_KEY": conf.get("openai", "api_key"),
        "OPENAI_TEMPERATURE": conf.get("openai", "temperature"),
        # qa
        "QA_COLLECTION": conf.get("qa", "collection"),
        "QA_SCORE": conf.get("qa", "score"),
        "QA_LIMIT": conf.get("qa", "limit"),
        # intent
        "INTENT_COLLECTION": conf.get("intent", "collection"),
        "INTENT_SCORE": conf.get("intent", "score"),
        "INTENT_LIMIT": conf.get("intent", "limit"),
    }

    base_config.update(new_config)
