# coding=utf-8

from .datasource import DataSource
from .common import BotPayload


class ChatGPTBot:
    def __init__(self, data_source: DataSource):
        self.data_source = data_source

    def complete(self, prompt: str) -> BotPayload:
        answer = self.data_source.search(prompt)
        resp = {"question": prompt, "answer": answer}
        return BotPayload.factory(**resp)
