# coding=utf-8

from .datasource import QDDataSource


class BaseQDBot:
    def __init__(self, data_source: QDDataSource):
        self.data_source = data_source

    def create_collection(self):
        """创建数据集

        Args:
            size (int): 向量大小
            distance (QdrantClient.Distance): 损失函数
        """
        try:
            self.data_source.create_collection(collection=self.collection)
        except Exception as e:
            raise e

    def upload_csv(self, filepath: str):
        """导入csv数据集

        Args:
            filepath: 文件路径
        """
        self.data_source.upload_csv(
            self.collection, self.embdder, filepath, self.formatter
        )


class BotPayload:
    @classmethod
    def factory(cls, **kwargs):
        return cls(
            **{
                key: value
                for key, value in kwargs.items()
                if not key.startswith("_") and not key.startswith("__")
            }
        )

    def __init__(self, question: str, answer: str, **kwargs):
        self.question = question
        self.answer = answer
        for k, v in kwargs.items():
            setattr(self, k, v)

    def to_dict(self):
        return {
            key: value
            for key, value in self.__dict__.items()
            if not key.startswith("_")
        }
